/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name:  $
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.example.swing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URISyntaxException;
import java.security.Principal;
import java.util.Iterator;
import java.util.Set;

import java.util.logging.Logger;
import javax.security.auth.Subject;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import net.sf.jguard.core.principals.RolePrincipal;
import net.sf.jguard.core.principals.UserPrincipal;
import net.sf.jguard.example.swing.dialog.CheckPermissionDialog;



/**
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 * @author <a href="mailto:vberetti@users.sourceforge.net">Vincent Beretti</a>
 */
public class JGuardSwingExample extends JFrame {

	private static final Logger logger = Logger.getLogger(JGuardSwingExample.class.getName());
	private static final long serialVersionUID = 417348431355013808L;

	private Subject loggedSubject;


	public JGuardSwingExample() throws URISyntaxException{
            handleLogin();
		//super("jGuard Swing Example");
                
               /* URL url = Thread.currentThread().getContextClassLoader().getResource("jGuardAuthentication.xml");
                Map authenticationSettings = AuthenticationHelper.loadConfiguration(url.toURI().toString(),"");*/
                /*JGuardConfiguration jGuardConf = new JGuardConfiguration();
                String applicationName = "jguard-swing-example";
                AuthenticationManager authenticationManager = AuthenticationHelper.initAuthentication(jGuardConf,authenticationSettings,applicationName);*/
		JButton loginButton = new JButton("Log in");
		loginButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				handleLogin();
			}
		});
		this.getContentPane().add(loginButton);

		this.pack();
		this.setLocation(400,200);
		this.setVisible(true);
	}

	private void handleLogin(){

		LoginContext lc = null;
		try {
			lc = new LoginContext("jguard-swing-example",new SwingCallbackHandler(this));
			lc.login();
		} catch (LoginException e) {
			logger.severe("LoginException : "+e.getMessage());
			return;
		}
		lc.getSubject().getPrincipals().add(new UserPrincipal(lc.getSubject()));


		loggedSubject=lc.getSubject();
			Set ppals=lc.getSubject().getPrincipals(RolePrincipal.class);
			logger.info("user logged with "+ppals.size()+" principals");
			Iterator itPpals=ppals.iterator();
			while(itPpals.hasNext()){
				Principal ppal=(Principal)itPpals.next();
                                logger.info("user logged with "+ppal.getName());
				logger.info(ppal.getName()+" "+ppal.getClass());
			}
		

		Set principals = lc.getSubject().getPrincipals();
		Iterator itPrincipals = principals.iterator();
		StringBuffer strPpal = new StringBuffer();
		while (itPrincipals.hasNext()){
			strPpal.append(((Principal)itPrincipals.next()).getName()+", ");
		}

		JOptionPane.showMessageDialog(this, "You are now logged as "+ strPpal.toString(), "Logged as", JOptionPane.INFORMATION_MESSAGE);


		new CheckPermissionDialog(this,loggedSubject);
	}

	public static void main(String args[]) throws URISyntaxException{
		new JGuardSwingExample();
	}

}
